/****************************************
 * 		NDS NeHe Lesson 04    			*
 * 		Author: Dovoto				*
 ****************************************/

// include your ndslib
#include <nds.h>


int DrawGLScene();

u16 angle;				// Angle For The Triangle ( NEW )

int main()
{	
	// Turn on everything
	powerON(POWER_ALL);

	// Setup the Main screen for 3D 
	videoSetMode(MODE_0_3D);
	
	// IRQ basic setup
	irqInit();
	irqSet(IRQ_VBLANK, 0);

	// initialize the geometry engine
	glInit();
	
	// enable antialiasing
	glEnable(GL_ANTIALIAS);
	
	// setup the rear plane
	glClearColor(16,16,31,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	glClearDepth(0x7FFF);

	// Set our viewport to be the same size as the screen
	glViewport(0,0,255,191);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(70, 256.0 / 192.0, 0.1, 100);
	
	//ds specific, several attributes can be set here	
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_NONE);
	
	// Set the current matrix to be the model matrix
	glMatrixMode(GL_MODELVIEW);
	
	while (1) 
	{
		// draw the scene
		DrawGLScene();
		
		// flush to screen	
		glFlush(0);
		
		// wait for the screen to refresh
		swiWaitForVBlank();
	}
	
	return 0;
}

int DrawGLScene()											// Here's Where We Do All The Drawing
{
	/*ds does this automagicaly*///glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear Screen And Depth Buffer
	glLoadIdentity();
	glTranslatef(0, 0, -3);
	glRotatef(angle, 1, 1, 0);
	
	glBegin(GL_TRIANGLES);
		glColor3f(1, 1, 1);		glVertex3f( 0, 1, 0); //sommet
		glColor3f(0, 0, 1);		glVertex3f( 1,-1, 1);
		glColor3f(0, 1, 0);		glVertex3f(-1,-1, 1);
	
		glColor3f(1, 1, 1);		glVertex3f( 0, 1, 0); //sommet
		glColor3f(1, 0, 0);		glVertex3f( 0,-1,-1);
		glColor3f(0, 0, 1);		glVertex3f( 1,-1, 1);
	
		glColor3f(1, 1, 1);		glVertex3f( 0, 1, 0); //sommet
		glColor3f(0, 1, 0);		glVertex3f(-1,-1, 1);
		glColor3f(1, 0, 0);		glVertex3f( 0,-1,-1);
	
		glColor3f(1, 0, 0);		glVertex3f( 0,-1,-1);
		glColor3f(0, 0, 1);		glVertex3f( 1,-1, 1);
		glColor3f(0, 1, 0);		glVertex3f(-1,-1, 1);
	glEnd();
	
	angle++;


return TRUE;
}
